"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const typedi_1 = require("typedi");
const manager_1 = require("./manager");
const proxy_1 = require("./proxy");
const services_1 = require("./services");
let App = class App {
    start(proxyPort = 8001, managerPort = 40001) {
        return __awaiter(this, void 0, void 0, function* () {
            const appInfoService = typedi_1.Container.get(services_1.AppInfoService);
            this.proxy.ignore(`127.0.0.1:${managerPort}`);
            this.proxy.ignore(`${appInfoService.getPcIp()}:${managerPort}`);
            this.proxy.listen(proxyPort);
            this.manager.listen(managerPort);
            appInfoService.setHttpProxyPort(proxyPort);
            appInfoService.setRealUiPort(managerPort);
            appInfoService.printRuntimeInfo();
        });
    }
    init() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.proxy.init();
        });
    }
};
__decorate([
    typedi_1.Inject(),
    __metadata("design:type", proxy_1.Proxy)
], App.prototype, "proxy", void 0);
__decorate([
    typedi_1.Inject(),
    __metadata("design:type", manager_1.Manager)
], App.prototype, "manager", void 0);
App = __decorate([
    typedi_1.Service()
], App);
exports.default = App;
//# sourceMappingURL=index.js.map