"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const typedi_1 = require("typedi");
const services_1 = require("../../services");
let HttpTrafficController = class HttpTrafficController {
    regist(router) {
        // 获取响应body
        router.get('/traffic/getResponseBody', (ctx) => __awaiter(this, void 0, void 0, function* () {
            const userId = ctx.userId;
            const id = ctx.query.id;
            const content = yield this.httpTrafficService.getResponseBody(userId, id);
            ctx.body = content;
        }));
        router.get('/traffic/getRequestBody', (ctx) => __awaiter(this, void 0, void 0, function* () {
            const userId = ctx.userId;
            const id = ctx.query.id;
            const content = yield this.httpTrafficService.getRequestBody(userId, id);
            ctx.body = content;
        }));
        router.get('/traffic/stopRecord', (ctx) => __awaiter(this, void 0, void 0, function* () {
            const userId = ctx.userId;
            const stopRecord = ctx.query.stop;
            yield this.httpTrafficService.setStopRecord(userId, stopRecord.toString() === 'true');
            ctx.body = {
                code: 0,
            };
        }));
        router.get('/traffic/setfilter', (ctx) => __awaiter(this, void 0, void 0, function* () {
            const userId = ctx.userId;
            const { filter = '' } = ctx.query;
            yield this.httpTrafficService.setFilter(userId, filter);
            ctx.body = {
                code: 0,
            };
        }));
        router.get('/traffic/clear', (ctx) => __awaiter(this, void 0, void 0, function* () {
            const userId = ctx.userId;
            yield this.httpTrafficService.clear(userId);
            ctx.body = {
                code: 0,
            };
        }));
        // 获取请求body
        router.get('/traffic/getRequestBody', (ctx) => __awaiter(this, void 0, void 0, function* () {
            const userId = ctx.userId;
            const id = ctx.query.id;
            const content = yield this.httpTrafficService.getRequestBody(userId, id);
            ctx.body = content;
        }));
    }
};
__decorate([
    typedi_1.Inject(),
    __metadata("design:type", services_1.HttpTrafficService)
], HttpTrafficController.prototype, "httpTrafficService", void 0);
HttpTrafficController = __decorate([
    typedi_1.Service()
], HttpTrafficController);
exports.HttpTrafficController = HttpTrafficController;
//# sourceMappingURL=httpTraffic.js.map