"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const url_1 = __importDefault(require("url"));
exports.host = (hostService, profileService) => {
    return (ctx, next) => __awaiter(this, void 0, void 0, function* () {
        if (ctx.ignore) {
            yield next();
            return;
        }
        if (!profileService.enableHost(ctx.userID)) {
            yield next();
            return;
        }
        const { req, res } = ctx;
        if (!(lodash_1.isNull(res.body) || lodash_1.isUndefined(res.body))) {
            yield next();
            return;
        }
        const url = url_1.default.parse(req.url);
        url.hostname = yield hostService.resolveHost(ctx.userID, url.hostname);
        url.host = url.hostname;
        if (url.port) {
            url.host = `${url.host}:${url.port}`;
        }
        req.url = url_1.default.format(url);
        yield next();
    });
};
//# sourceMappingURL=host.js.map