"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class Ignorer {
    constructor() {
        this.patterns = [];
    }
    addPattern(pattern) {
        this.patterns.push(pattern);
    }
    middleware(ctx, next) {
        return __awaiter(this, void 0, void 0, function* () {
            let shouldIgnore = false;
            for (const pattern of this.patterns) {
                if (ctx.req.url.includes(pattern)) {
                    shouldIgnore = true;
                    break;
                }
            }
            if (shouldIgnore) {
                ctx.ignore = true;
            }
            yield next();
        });
    }
}
exports.Ignorer = Ignorer;
//# sourceMappingURL=ignore.js.map