"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const stream_1 = __importDefault(require("stream"));
class HttpHandler {
    constructor() {
        this.middleware = () => Promise.resolve(null);
    }
    handle(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            const context = {
                req,
                res,
            };
            this.middleware(context).then(() => {
                if (!res.writable || res.finished) {
                    return Promise.resolve(false);
                }
                const { body } = res;
                if (!body) {
                    res.end('');
                }
                if (Buffer.isBuffer(body)) {
                    return res.end(body);
                }
                if ('string' === typeof body) {
                    return res.end(body);
                }
                if (body instanceof stream_1.default) {
                    return body.pipe(res);
                }
                return res.end(JSON.stringify(body));
            });
        });
    }
    setMiddleware(middleware) {
        this.middleware = middleware;
    }
}
exports.HttpHandler = HttpHandler;
//# sourceMappingURL=http.js.map