"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const typedi_1 = require("typedi");
const App_1 = __importDefault(require("../App"));
exports.default = (proxyPort, uiPort) => __awaiter(this, void 0, void 0, function* () {
    const app = typedi_1.Container.get(App_1.default);
    yield app.init();
    app.start(proxyPort, uiPort);
    process.on('unhandledRejection', (reason, p) => {
        if (process.env.DEBUG) {
            console.error('Unhandled Rejection at: Promise ', p, ' reason: ', reason);
        }
    });
    process.on('SIGINT', () => {
        process.exit();
    });
    process.on('uncaughtException', err => {
        if (process.env.DEBUG) {
            console.error(err);
        }
    });
});
//# sourceMappingURL=start.js.map