"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ora_1 = __importDefault(require("ora"));
const services_1 = require("./../App/services");
const syncRemoteHosts = () => __awaiter(this, void 0, void 0, function* () {
    console.log('开始同步远程Host文件');
    const appInfoService = new services_1.AppInfoService(false);
    const hostService = new services_1.HostService(appInfoService);
    const hostFileList = hostService.getHostFileList('root');
    for (const hostFile of hostFileList) {
        if (!hostFile.meta) {
            continue;
        }
        if (!hostFile.meta.url || hostFile.meta.local) {
            continue;
        }
        const spinner = ora_1.default(`同步远程Host${hostFile.name}`).start();
        try {
            yield hostService.importRemoteHostFile('root', hostFile.meta.url);
            spinner.succeed();
        }
        catch (e) {
            spinner.fail();
        }
    }
    console.log('同步远程Host文件结束');
});
exports.default = syncRemoteHosts;
//# sourceMappingURL=syncHost.js.map