"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ora_1 = __importDefault(require("ora"));
const services_1 = require("./../App/services");
const syncRemoteRules = () => __awaiter(this, void 0, void 0, function* () {
    console.log('开始同步远程规则集');
    const appInfoService = new services_1.AppInfoService(false);
    const ruleService = new services_1.RuleService(appInfoService);
    const userIDs = Object.keys(ruleService.rules);
    for (const userID of userIDs) {
        const userRuleFilesMap = ruleService.rules[userID];
        const userRuleFiles = Object.keys(userRuleFilesMap).map(k => userRuleFilesMap[k]);
        for (const ruleFile of userRuleFiles) {
            if (ruleFile.meta && ruleFile.meta.remote && !ruleFile.disableSync) {
                const spinner = ora_1.default(`同步规则集${ruleFile.name}`).start();
                try {
                    yield ruleService.importRemoteRuleFile(userID, ruleFile.meta.url);
                    spinner.succeed();
                }
                catch (e) {
                    spinner.fail();
                }
            }
        }
    }
    console.log('同步远程规则集结束');
});
exports.default = syncRemoteRules;
//# sourceMappingURL=syncRule.js.map